install.sh 10 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228
  1. #!/bin/bash
  2. red='\033[0;31m'
  3. green='\033[0;32m'
  4. blue='\033[0;34m'
  5. yellow='\033[0;33m'
  6. plain='\033[0m'
  7. cur_dir=$(pwd)
  8. # check root
  9. [[ $EUID -ne 0 ]] && echo -e "${red}Fatal error: ${plain} Please run this script with root privilege \n " && exit 1
  10. # Check OS and set release variable
  11. if [[ -f /etc/os-release ]]; then
  12. source /etc/os-release
  13. release=$ID
  14. elif [[ -f /usr/lib/os-release ]]; then
  15. source /usr/lib/os-release
  16. release=$ID
  17. else
  18. echo "Failed to check the system OS, please contact the author!" >&2
  19. exit 1
  20. fi
  21. echo "The OS release is: $release"
  22. arch() {
  23. case "$(uname -m)" in
  24. x86_64 | x64 | amd64) echo 'amd64' ;;
  25. i*86 | x86) echo '386' ;;
  26. armv8* | armv8 | arm64 | aarch64) echo 'arm64' ;;
  27. armv7* | armv7 | arm) echo 'armv7' ;;
  28. armv6* | armv6) echo 'armv6' ;;
  29. armv5* | armv5) echo 'armv5' ;;
  30. s390x) echo 's390x' ;;
  31. *) echo -e "${green}Unsupported CPU architecture! ${plain}" && rm -f install.sh && exit 1 ;;
  32. esac
  33. }
  34. echo "Arch: $(arch)"
  35. check_glibc_version() {
  36. glibc_version=$(ldd --version | head -n1 | awk '{print $NF}')
  37. required_version="2.32"
  38. if [[ "$(printf '%s\n' "$required_version" "$glibc_version" | sort -V | head -n1)" != "$required_version" ]]; then
  39. echo -e "${red}GLIBC version $glibc_version is too old! Required: 2.32 or higher${plain}"
  40. echo "Please upgrade to a newer version of your operating system to get a higher GLIBC version."
  41. exit 1
  42. fi
  43. echo "GLIBC version: $glibc_version (meets requirement of 2.32+)"
  44. }
  45. check_glibc_version
  46. install_base() {
  47. case "${release}" in
  48. ubuntu | debian | armbian)
  49. apt-get update && apt-get install -y -q wget curl tar tzdata
  50. ;;
  51. centos | almalinux | rocky | ol)
  52. yum -y update && yum install -y -q wget curl tar tzdata
  53. ;;
  54. fedora | amzn | virtuozzo)
  55. dnf -y update && dnf install -y -q wget curl tar tzdata
  56. ;;
  57. arch | manjaro | parch)
  58. pacman -Syu && pacman -Syu --noconfirm wget curl tar tzdata
  59. ;;
  60. opensuse-tumbleweed)
  61. zypper refresh && zypper -q install -y wget curl tar timezone
  62. ;;
  63. *)
  64. apt-get update && apt install -y -q wget curl tar tzdata
  65. ;;
  66. esac
  67. }
  68. gen_random_string() {
  69. local length="$1"
  70. local random_string=$(LC_ALL=C tr -dc 'a-zA-Z0-9' </dev/urandom | fold -w "$length" | head -n 1)
  71. echo "$random_string"
  72. }
  73. config_after_install() {
  74. local existing_username=$(/usr/local/x-ui/x-ui setting -show true | grep -Eo 'username: .+' | awk '{print $2}')
  75. local existing_password=$(/usr/local/x-ui/x-ui setting -show true | grep -Eo 'password: .+' | awk '{print $2}')
  76. local existing_webBasePath=$(/usr/local/x-ui/x-ui setting -show true | grep -Eo 'webBasePath: .+' | awk '{print $2}')
  77. local existing_port=$(/usr/local/x-ui/x-ui setting -show true | grep -Eo 'port: .+' | awk '{print $2}')
  78. local server_ip=$(curl -s https://api.ipify.org)
  79. if [[ ${#existing_webBasePath} -lt 4 ]]; then
  80. if [[ "$existing_username" == "admin" && "$existing_password" == "admin" ]]; then
  81. local config_webBasePath=$(gen_random_string 15)
  82. local config_username=$(gen_random_string 10)
  83. local config_password=$(gen_random_string 10)
  84. read -p "Would you like to customize the Panel Port settings? (If not, a random port will be applied) [y/n]: " config_confirm
  85. if [[ "${config_confirm}" == "y" || "${config_confirm}" == "Y" ]]; then
  86. read -p "Please set up the panel port: " config_port
  87. echo -e "${yellow}Your Panel Port is: ${config_port}${plain}"
  88. else
  89. local config_port=$(shuf -i 1024-62000 -n 1)
  90. echo -e "${yellow}Generated random port: ${config_port}${plain}"
  91. fi
  92. /usr/local/x-ui/x-ui setting -username "${config_username}" -password "${config_password}" -port "${config_port}" -webBasePath "${config_webBasePath}"
  93. echo -e "This is a fresh installation, generating random login info for security concerns:"
  94. echo -e "###############################################"
  95. echo -e "${green}Username: ${config_username}${plain}"
  96. echo -e "${green}Password: ${config_password}${plain}"
  97. echo -e "${green}Port: ${config_port}${plain}"
  98. echo -e "${green}WebBasePath: ${config_webBasePath}${plain}"
  99. echo -e "${green}Access URL: http://${server_ip}:${config_port}/${config_webBasePath}${plain}"
  100. echo -e "###############################################"
  101. echo -e "${yellow}If you forgot your login info, you can type 'x-ui settings' to check${plain}"
  102. else
  103. local config_webBasePath=$(gen_random_string 15)
  104. echo -e "${yellow}WebBasePath is missing or too short. Generating a new one...${plain}"
  105. /usr/local/x-ui/x-ui setting -webBasePath "${config_webBasePath}"
  106. echo -e "${green}New WebBasePath: ${config_webBasePath}${plain}"
  107. echo -e "${green}Access URL: http://${server_ip}:${existing_port}/${config_webBasePath}${plain}"
  108. fi
  109. else
  110. if [[ "$existing_username" == "admin" && "$existing_password" == "admin" ]]; then
  111. local config_username=$(gen_random_string 10)
  112. local config_password=$(gen_random_string 10)
  113. echo -e "${yellow}Default credentials detected. Security update required...${plain}"
  114. /usr/local/x-ui/x-ui setting -username "${config_username}" -password "${config_password}"
  115. echo -e "Generated new random login credentials:"
  116. echo -e "###############################################"
  117. echo -e "${green}Username: ${config_username}${plain}"
  118. echo -e "${green}Password: ${config_password}${plain}"
  119. echo -e "###############################################"
  120. echo -e "${yellow}If you forgot your login info, you can type 'x-ui settings' to check${plain}"
  121. else
  122. echo -e "${green}Username, Password, and WebBasePath are properly set. Exiting...${plain}"
  123. fi
  124. fi
  125. /usr/local/x-ui/x-ui migrate
  126. }
  127. install_x-ui() {
  128. cd /usr/local/
  129. if [ $# == 0 ]; then
  130. tag_version=$(curl -Ls "https://api.github.com/repos/MHSanaei/3x-ui/releases/latest" | grep '"tag_name":' | sed -E 's/.*"([^"]+)".*/\1/')
  131. if [[ ! -n "$tag_version" ]]; then
  132. echo -e "${red}Failed to fetch x-ui version, it may be due to GitHub API restrictions, please try it later${plain}"
  133. exit 1
  134. fi
  135. echo -e "Got x-ui latest version: ${tag_version}, beginning the installation..."
  136. wget -N -O /usr/local/x-ui-linux-$(arch).tar.gz https://github.com/MHSanaei/3x-ui/releases/download/${tag_version}/x-ui-linux-$(arch).tar.gz
  137. if [[ $? -ne 0 ]]; then
  138. echo -e "${red}Downloading x-ui failed, please be sure that your server can access GitHub ${plain}"
  139. exit 1
  140. fi
  141. else
  142. tag_version=$1
  143. tag_version_numeric=${tag_version#v}
  144. min_version="2.3.5"
  145. if [[ "$(printf '%s\n' "$min_version" "$tag_version_numeric" | sort -V | head -n1)" != "$min_version" ]]; then
  146. echo -e "${red}Please use a newer version (at least v2.3.5). Exiting installation.${plain}"
  147. exit 1
  148. fi
  149. url="https://github.com/MHSanaei/3x-ui/releases/download/${tag_version}/x-ui-linux-$(arch).tar.gz"
  150. echo -e "Beginning to install x-ui $1"
  151. wget -N -O /usr/local/x-ui-linux-$(arch).tar.gz ${url}
  152. if [[ $? -ne 0 ]]; then
  153. echo -e "${red}Download x-ui $1 failed, please check if the version exists ${plain}"
  154. exit 1
  155. fi
  156. fi
  157. if [[ -e /usr/local/x-ui/ ]]; then
  158. systemctl stop x-ui
  159. rm /usr/local/x-ui/ -rf
  160. fi
  161. tar zxvf x-ui-linux-$(arch).tar.gz
  162. rm x-ui-linux-$(arch).tar.gz -f
  163. cd x-ui
  164. chmod +x x-ui
  165. # Check the system's architecture and rename the file accordingly
  166. if [[ $(arch) == "armv5" || $(arch) == "armv6" || $(arch) == "armv7" ]]; then
  167. mv bin/xray-linux-$(arch) bin/xray-linux-arm
  168. chmod +x bin/xray-linux-arm
  169. fi
  170. chmod +x x-ui bin/xray-linux-$(arch)
  171. cp -f x-ui.service /etc/systemd/system/
  172. wget -O /usr/bin/x-ui https://raw.githubusercontent.com/MHSanaei/3x-ui/main/x-ui.sh
  173. chmod +x /usr/local/x-ui/x-ui.sh
  174. chmod +x /usr/bin/x-ui
  175. config_after_install
  176. systemctl daemon-reload
  177. systemctl enable x-ui
  178. systemctl start x-ui
  179. echo -e "${green}x-ui ${tag_version}${plain} installation finished, it is running now..."
  180. echo -e ""
  181. echo -e "┌───────────────────────────────────────────────────────┐
  182. │ ${blue}x-ui control menu usages (subcommands):${plain} │
  183. │ │
  184. │ ${blue}x-ui${plain} - Admin Management Script │
  185. │ ${blue}x-ui start${plain} - Start │
  186. │ ${blue}x-ui stop${plain} - Stop │
  187. │ ${blue}x-ui restart${plain} - Restart │
  188. │ ${blue}x-ui status${plain} - Current Status │
  189. │ ${blue}x-ui settings${plain} - Current Settings │
  190. │ ${blue}x-ui enable${plain} - Enable Autostart on OS Startup │
  191. │ ${blue}x-ui disable${plain} - Disable Autostart on OS Startup │
  192. │ ${blue}x-ui log${plain} - Check logs │
  193. │ ${blue}x-ui banlog${plain} - Check Fail2ban ban logs │
  194. │ ${blue}x-ui update${plain} - Update │
  195. │ ${blue}x-ui legacy${plain} - legacy version │
  196. │ ${blue}x-ui install${plain} - Install │
  197. │ ${blue}x-ui uninstall${plain} - Uninstall │
  198. └───────────────────────────────────────────────────────┘"
  199. }
  200. echo -e "${green}Running...${plain}"
  201. install_base
  202. install_x-ui $1